//
//	Copyright (C) 2003 Kazuhiko TAMURA. All rights reserved.
//
//	This program is free software; you can redistribute it and/or 
//	modify it under the terms of the GNU General Public License
//	as published by the Free Software Foundation; either version 2
//	of the License, or (at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//	NAME:		SolverModelState.java
//	DATE:		2003.8.30
//	CREATOR:	Kazuhiko TAMURA
//
// ***************************************************************************************

package jp.gr.java_conf.ktz.puzzle.hashikake.util;

import jp.gr.java_conf.ktz.puzzle.framework.ModelState;

/**
 *	SolverStateModelʂ邩ǂ߂郂f
 */
class SolverModelState extends ModelState {
	private static final ModelState ACCEPT_SOLVER_STATE = new SolverModelState();
	private static final ModelState DENIED_SOLVER_STATE = new SolverModelState();

	private SolverModelState() {
	}
	
	static ModelState createSolverModelState(final boolean inIsAccept) {
		if (inIsAccept) {
			return ACCEPT_SOLVER_STATE;
		}
		else {
			return DENIED_SOLVER_STATE;
		}
	}
	
	static boolean isAcceptSolverModelState(ModelState inState) {
		return (inState == ACCEPT_SOLVER_STATE);
	}
}
